<?php
/**
 * @package 	WooCommerce Product Barcode Label Printing
 * @version 	1.1.0.7
 * 
 * Functions Page
 * 
**/



// Notices
function wpblp_free_notices() {	
	global $pagenow, $plugin_page;
	$page_url = add_query_arg('page', $plugin_page, admin_url($pagenow));
	$user_id = get_current_user_id();
	$screen = get_current_screen();
	
	if (
		$screen->id == 'toplevel_page_wpblp_select_products' || 
		$screen->id == 'woolabel_page_wpblp_settings_page' || 
		$screen->id == 'woolabel_page_wpblp_info_page'
	) {
		if (!get_user_meta($user_id, 'wpblp_plugin_notices_dismissed_1_date')) {
			update_user_meta($user_id, 'wpblp_plugin_notices_dismissed_1_date', date('d.m.Y'));
		} else {
			$current_date = strtotime(date('d.m.Y'));
			$wpblp_plugin_notices_dismissed_1_date = strtotime("+1 week", strtotime(get_user_meta($user_id, 'wpblp_plugin_notices_dismissed_1_date', true)));
			
			if ($current_date > $wpblp_plugin_notices_dismissed_1_date) {
				update_user_meta($user_id, 'wpblp_plugin_notices_dismissed_1_date', date('d.m.Y'));
				delete_user_meta($user_id, 'wpblp_plugin_notices_dismissed_1');
			}
		}
		
		if (!get_user_meta($user_id, 'wpblp_plugin_notices_dismissed_1')) {
			$page_url1 = add_query_arg('wpblp-dismissed1', 'true', $page_url);
			
			echo '<div class="notice notice-info wpblp_admin_notice_info">' . 
				'<p>' . __('Woolabel Premium Plugin is now available for purchase! Grab your copy today! Read what new features it has, <a href="https://codecanyon.net/item/woocommerce-product-barcode-label-printing-premium-woolabel/23292767?ref=wooaddons">click here</a>', 'woo-product-barcode-label-printing') . '</p>' . 
				'<a class="notice-dismiss" href="' . esc_url($page_url1) . '"><span>' . __('Dismiss', 'woo-product-barcode-label-printing') . '</span></a>' . 
			'</div>';
		}
		
		if (!get_user_meta($user_id, 'wpblp_plugin_notices_dismissed_2')) {
			$page_url2 = add_query_arg('wpblp-dismissed2', 'true', $page_url);
			
			echo '<div class="notice notice-info wpblp_admin_notice_info">' . 
				'<p>' . __('If you like our plugin please leave a <a href="https://wordpress.org/support/plugin/woo-product-barcode-label-printing/reviews/#new-post">feedback</a>', 'woo-product-barcode-label-printing') . '</p>' . 
				'<a class="notice-dismiss" href="' . esc_url($page_url2) . '"><span>' . __('Dismiss', 'woo-product-barcode-label-printing') . '</span></a>' . 
			'</div>';
		}
	}
}
add_action('admin_notices', 'wpblp_free_notices');


function wpblp_free_notices_dismissed() {
    $user_id = get_current_user_id();
	
    if (isset($_GET['wpblp-dismissed1'])) {
        update_user_meta($user_id, 'wpblp_plugin_notices_dismissed_1', 'true');
		update_user_meta($user_id, 'wpblp_plugin_notices_dismissed_1_date', date('d.m.Y'));
	}
	
    if (isset($_GET['wpblp-dismissed2'])) {
        update_user_meta($user_id, 'wpblp_plugin_notices_dismissed_2', 'true');
	}
}
add_action('admin_init', 'wpblp_free_notices_dismissed');


/*
 * Deactivation Popup
 */
// Action Link
add_filter('plugin_action_links_' . plugin_basename(WOO_PRODUCT_BARCODE_LABEL_PRINTING_FILE), function($links) {
    if (array_key_exists('deactivate', $links)) {
        $links['deactivate'] = str_replace('<a', '<a class="wpblp_deactivation_link"', $links['deactivate']);
    }
	
    return $links;
});


// Popup AJAX
function wpblp_get_site_name() {
	$site_name = get_bloginfo( 'name' );
	
	if (empty($site_name)) {
		$site_name = get_bloginfo('description');
		$site_name = wp_trim_words($site_name, 3, '');
	}
	
	if (empty($site_name)) {
		$site_name = get_bloginfo('url');
	}
	
	return $site_name;
}


add_action('wp_ajax_wpblp_submit_uninstall_reason', function() {
	if (!isset($_POST['reason'])) {
		wp_send_json_error();
	}
	
	$url 			= 'https://woolabel.com/free-feedback-handler';
	$current_user 	= wp_get_current_user();
	
	$params = array(
		'wpblp_response'	=> true, 
		'reason' 	  		=> isset($_REQUEST['reason'] ) ? trim(stripslashes($_REQUEST['reason'])) : '',
		'site'        		=> wpblp_get_site_name(),
		'url'         		=> esc_url(home_url()),
		'admin_email' 		=> get_option('admin_email'),
		'user_email'  		=> $current_user->user_email,
		'first_name'  		=> $current_user->first_name,
		'last_name'   		=> $current_user->last_name,
	);
	
	wp_remote_post(esc_url($url), array(
		'method'      => 'POST',
		'timeout'     => 60, 
		'redirection' => 5,
		'blocking'    => true,
		'headers'     => array(),
		'body'        => $params,
	));
	
	wp_send_json_success();
});


// Popup
add_action('admin_footer', function() {
	global $pagenow;
	
    if ('plugins.php' != $pagenow) {
		return;
	}
	?>
	<div class="wpblp_deactivation_modal" id="wpblp_deactivation_popup">
		<div class="wpblp_deactivation_modal_wrap">
			<div class="wpblp_deactivation_modal_header">
				<h3><?php _e('Hey, can you provide feedback on why you are deactivating our plugin? Thanks', 'woo-product-barcode-label-printing'); ?></h3>
			</div>
			<div class="wpblp_deactivation_modal_body">				
				<textarea rows="5" cols="45" placeholder="<?php _e('Enter text...', 'woo-product-barcode-label-printing'); ?>"></textarea>
			</div>
			<div class="wpblp_deactivation_modal_footer">
				<a href="#" class="wpblp_deactivation_dont_bother_me"><?php _e('I rather wouldn\'t say', 'woo-product-barcode-label-printing'); ?></a>
				<button class="button-secondary"><?php _e('Submit & Deactivate', 'woo-product-barcode-label-printing'); ?></button>
				<button class="button-primary"><?php _e( 'Cancel', 'woo-product-barcode-label-printing' ); ?></button>
			</div>
		</div>
	</div>
	<script>
	// Deactivation Popup
	jQuery(document).ready(function($) {
	    "use strict";
	    
	    var deactivation_modal = $('#wpblp_deactivation_popup'), 
	        deactivation_link = '';
	    
	    $('#the-list').on('click', 'a.wpblp_deactivation_link', function(e) {
	        e.preventDefault();
	        
	        deactivation_modal.addClass('wpblp_deactivation_modal_active');
	        deactivation_link = $(this).attr('href');
	        deactivation_modal.find('a.wpblp_deactivation_dont_bother_me').attr('href', deactivation_link).css('float', 'left');
	    });
	    
	    deactivation_modal.on('click', 'button.button-primary', function(e) {
	        e.preventDefault();
	        deactivation_modal.removeClass('wpblp_deactivation_modal_active');
	    });
	    
	    deactivation_modal.on('click', 'button.button-secondary', function(e) {
	        e.preventDefault();
	        var $button = $(this);
	        var $reason = deactivation_modal.find('textarea').val();
	        
	        if ($button.hasClass('disabled')) {
	            return;
	        }
	        
	        if ($reason != '') {
	            $.ajax({
	                url: ajaxurl,
	                type: 'POST',
	                data: {
	                    action: 'wpblp_submit_uninstall_reason',
	                    reason: $reason
	                },
	                beforeSend: function() {
	                    $button.addClass('disabled');
	                },
	                complete: function() {
	                    window.location.href = deactivation_link;
	                }
	            });
	        }
	    });
	});
	</script>
	<style>
	.wpblp_deactivation_modal{position:fixed;z-index:99999;top:0;right:0;bottom:0;left:0;background:rgba(0,0,0,0.5);display:none}.wpblp_deactivation_modal.wpblp_deactivation_modal_active{display:block}.wpblp_deactivation_modal_wrap{width:475px;position:relative;margin:10% auto;background:#fff}.wpblp_deactivation_modal_header{border-bottom:1px solid #eee;padding:8px 20px}.wpblp_deactivation_modal_header h3{line-height:150%;margin:0}.wpblp_deactivation_modal_body{padding:5px 20px 20px}.wpblp_deactivation_modal_body .reason-input{margin-top:5px;margin-left:20px}.wpblp_deactivation_modal_footer{border-top:1px solid #eee;padding:12px 20px;text-align:right}.wpblp_deactivation_modal_body textarea{width:100%;margin-top:10px}
	</style>
	<?php
});
?>